码迷,mamicode.com
首页 > 其他好文 > 详细

HDU-1300(DP)

时间:2015-11-02 12:08:05      阅读:165      评论:0      收藏:0      [点我收藏+]

标签:

Problem Description
In Pearlania everybody is fond of pearls. One company, called The Royal Pearl, produces a lot of jewelry with pearls in it. The Royal Pearl has its name because it delivers to the royal family of Pearlania. But it also produces bracelets and necklaces for ordinary people. Of course the quality of the pearls for these people is much lower then the quality of pearls for the royal family. In Pearlania pearls are separated into 100 different quality classes. A quality class is identified by the price for one single pearl in that quality class. This price is unique for that quality class and the price is always higher then the price for a pearl in a lower quality class.

Every month the stock manager of The Royal Pearl prepares a list with the number of pearls needed in each quality class. The pearls are bought on the local pearl market. Each quality class has its own price per pearl, but for every complete deal in a certain quality class one has to pay an extra amount of money equal to ten pearls in that class. This is to prevent tourists from buying just one pearl.

Also The Royal Pearl is suffering from the slow-down of the global economy. Therefore the company needs to be more efficient. The CFO (chief financial officer) has discovered that he can sometimes save money by buying pearls in a higher quality class than is actually needed. No customer will blame The Royal Pearl for putting better pearls in the bracelets, as long as the prices remain the same.

For example 5 pearls are needed in the 10 Euro category and 100 pearls are needed in the 20 Euro category. That will normally cost: (5+10)*10 + (100+10)*20 = 2350 Euro.

Buying all 105 pearls in the 20 Euro category only costs: (5+100+10)*20 = 2300 Euro.

The problem is that it requires a lot of computing work before the CFO knows how many pearls can best be bought in a higher quality class. You are asked to help The Royal Pearl with a computer program.

Given a list with the number of pearls and the price per pearl in different quality classes, give the lowest possible price needed to buy everything on the list. Pearls can be bought in the requested, or in a higher quality class, but not in a lower one.
 

 

Input
The first line of the input contains the number of test cases. Each test case starts with a line containing the number of categories c (1 <= c <= 100). Then, c lines follow, each with two numbers ai and pi. The first of these numbers is the number of pearls ai needed in a class (1 <= ai <= 1000). The second number is the price per pearl pi in that class (1 <= pi <= 1000). The qualities of the classes (and so the prices) are given in ascending order. All numbers in the input are integers.
 

 

Output
For each test case a single line containing a single number: the lowest possible price needed to buy everything on the list.
 

 

Sample Input
2 2 100 1 100 2 3 1 10 1 11 100 12
 

 

Sample Output
330 1344
思路:
这道题一拿上来想了一会儿就想出来解法,即像0-1背包那样的挨个试,先设置好第一个的值,然后外层循环从第2个开始遍历,内层循环就是扫从第一个到第i-1个的值
但是这个思路有个思维跳跃当时没有注意到:(1)某个等级的珠宝x只要被更高等级的某个珠宝y替代了,那它是可以随着y进一步被替代的;(2)某个等级的珠宝x如果不能被他的上一个等级x+1替代,那么他肯定就不能被更多的珠宝替代
下面的代码和被AC过的代码的测试数据都是完全相同的,但不知道还有哪里有差错,总是WA,先放到这里,以后再来查看

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

int T;
int number;
struct P{
    __int64 v;
    __int64 c;
}pearl[107];
int exits[107];
__int64 sum;

int main()
{
    scanf("%d",&T);
    while(T--)
    {
        sum = 0;
        scanf("%d",&number);
        for(int i = 1;i <= number;i++){
            scanf("%I64d%I64d",&pearl[i].c,&pearl[i].v);
            exits[i] = 1;
        }
        for(int i = 2;i <= number;i++)
            if(pearl[i-1].c*pearl[i].v < (pearl[i-1].c+10)*pearl[i-1].v){
                pearl[i].c += pearl[i-1].c;
                exits[i-1] = 0;
            }
        /*这一部分是没有想到(2)的思维跳跃
        for(int i = 2;i <= number;i++)
            for(int j = 1;j <= i-1;j++)
                if(exits[j])
                    if(pearl[j].c*pearl[i].v < (pearl[j].c+10)*pearl[j].v) {
                        exits[j] = 0;
                        pearl[i].c += pearl[j].c;
                    }
        */    
        for(int i = 1;i <= number;i++)
            if(exits[i]) sum += (pearl[i].c+10)*pearl[i].v;
        printf("%I64d\n",sum);
    }
    return 0;
}
 

HDU-1300(DP)

标签:

原文地址:http://www.cnblogs.com/immortal-worm/p/4929546.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!